require " startup.lua"
require "game/volume.lua"
require "game/music.lua"
require "splash/splashes.lua"
require "draw/menu.lua"
require "cam/camera.lua"
require "game/tables.lua"
require "steve/steve_animations.lua"
require "game/gun_properties.lua"
require "game/limits.lua"
require "draw/maps.lua"
require "conf.lua"
require "cam/camera_movements.lua"
require "zombie/zombie_animations.lua"
require "misc/funk-shuns.lua"
require "game/horde.lua"
require "zombie/zombie_attacks.lua"
require "game/bullets.lua"
require "debug/debug.lua"
require "steve/steve_attacks.lua"
require "draw/HUD.lua"


--my main.lua is VERRRRYYYY SLOPPY! Because this was my first actuall game.

function love.load()
	is_loading = true
	
	h_fadeTimer = 2

	--SOUNDS--mostly from the minecraft files, please don't sue me.
	click = love.audio.newSource("sounds/click.ogg")

	
	fade_timer = 0

	bulletx = steve.x + 64
	bullety = steve.y + 7
	bulletspeed = 1000
	
	----For The first time playing----
	horde_locked = true	
	----------------------------------
	
	----FONTS---
	large = love.graphics.newFont("font/minecraftfont/minecraft.ttf", 54)
	small = love.graphics.newFont("font/minecraftfont/minecraft.ttf", 12)
	huge = love.graphics.newFont("font/minecraftfont/minecraft.ttf", 70)
	splash_size = 2
	splash_font = love.graphics.newFont("font/minecraftfont/minecraft.ttf", 10)
	
	
	inhouse = false
	
	width = love.graphics.getWidth()
	
	-----Helps draw The Maps(maps.lua)-----
	---------------------------------
	
	--Helps to detect Wether something is being shot or not----
	shooting = false
	-------------------------
	-----gamestates------
	horde = false
	camp = false
	stats = false
	menu = false
	transition = false
	paused = false
	startup = true
	about = false
	
	--------------------
	startup_timer = 0

	--function spawnZombie(x,y,damage,speed)

	party_modeActive = false
	
	
	border_draw = false
	random_number = math.random(1,10)
	
	
	--horde mode--
	spawnchanceleft = 0.001999
	spawnchanceright = 0.001999
	zombiedamage = 0.1
	zombiespeed = 100
	direction = "right"
	shotgun_unlocked = false
	pistol_unlocked = false
	wave = 0
	spawnweight = 0
	moon = {}
	moon.speed = steve.speed - 10
	moon.x = camera.x + 600
	moon.pic = love.graphics.newImage("pics/moon.png")
	kills = 0
	kill_limit = 10
	timeshit = 0
	bullet_limit = 500	
	zombie_health = 4
	
	red = 232
	blue = 255
	green = 232
	rednight = 10
	greennight = 10
	bluenight= 35
	colorred = 255
	colorblue = 255
	colorgreen = 255
	housecolorred = 150
	housecolorblue = 150
	housecolorgreen = 150
	stevecolor_red = 255
	stevecolor_green = 255
	stevecolor_blue = 255
	zombiered = 255
	zombieblue = 255
	zombiegreen = 255

	one_shot = true
	shottimer = 0
	
	logo = love.graphics.newImage("pics/logo.png")
	camp_alpha = 255
	alpha = 0
	button3 = love.graphics.newImage("pics/button.png")
	button_highlighted = love.graphics.newImage("pics/button_highlighted.png")
	zombie_color = false
	zombie_dough = math.random(83,472)
	inv = love.graphics.newImage("pics/inv.png")
	in_house = false
	house_timer = 0
	bulletpic = love.graphics.newImage("pics/bullet.png")
	sign = love.graphics.newImage("pics/sign.png")
	signwidth = sign:getWidth()
	signheight = sign:getHeight()
	post = love.graphics.newImage("pics/post.png")
	postwidth = post:getWidth()
	button1 = love.graphics.newImage("pics/button.png")
	button2 = love.graphics.newImage("pics/button.png")
	postheight = post:getHeight()
	ground = love.graphics.newImage('pics/street.png')
	sun = love.graphics.newImage("pics/sun.png")
	gun_height = -10
	gun_width = 38
	groundWidth = ground:getWidth()
	groundHeight = ground:getHeight()

	zombie_killTimer = 0

	buttonwidth = button1:getWidth()
	buttonheight = button1:getHeight()

	background = love.graphics.newImage("pics/dirt background.jpeg")

	menu_alpha = 0
	menu_timer = 0.9
	
	zombie_fuckTimer = 1.1	
	math.randomseed(os.time())
	math.random()
	math.random()
	math.random()

	is_loading = false
	h_alpha = 255
	
	kill_weight = 5
	
end
function love.update(dt)
	
	
	if menu == true then
		
		menu_stuff(dt)
	end
	if startup == true then
		startup_function(dt)
	end

	function love.keypressed(key) --I messed up a little...So I had to put this in:p
		if steve.x + 48 > 310 and
		steve.x < 280 + postwidth and
		key == "j" then
			pistol_unlocked = true
			steve.is_equipped = "pistol"
			horde_locked = false
		end
		if steve.x + 48 > 310 + 69 and
		steve.x < 310 + 52 + postwidth and
		steve.money - 2699 > 0 and
		key == "j" then
			steve.money = steve.money - 2700
			steve.is_equipped = "shotgun"
			shotgun_unlocked = true
			horde_locked = false
		end
		if steve.x + 48 > 310 + 69 and
		steve.x < 310 + 52 + postwidth and
		steve.money - 350 < -1 and
		key == "j" then
			return nil
		end
		if steve.x + 48 > 310 + 69 and
		steve.x < 310 + 52 + postwidth and
		key == "j" and
		shotgun_unlocked == true then
			return nil
		end
		
		
	end
	if party_modeActive == true then
		buzz_kill()
		party_mode(dt)
		party_draw(dt)
	end
	
	if camp == true then
		steve_shoot(dt)
		steve_controlls(dt)
		camp_limits()
		camera_camp(dt)
		money()
		gun_equip()
		road_limits()
		love.graphics.setBackgroundColor(red,green,blue)
		bullet_movements(dt)
		kill_shit()
		stats = false
		
	end
	if steve.x > groundWidth * 5 - 43 and
	camp == true and
	horde_locked == false and
	awesome_timer == 3 then
		wave = wave + 1
		spawnweight = spawnweight + 0.001
		camp = false
		horde = true
		steve.x = 5
		camera.x = 0
		kill_weight = kill_weight + 2
		kill_limit = kill_limit + kill_weight
		zombie_health = zombie_health + 0.5
		kills = 0
	end

	if horde == true then
		steve_controlls(dt)
		steve_shoot(dt)
		horde_limits()
		zombie_spawning(dt)
		camera_horde()
		money()
		gun_equip()
		road_limits()
		zombie_movement(dt)
		love.graphics.setBackgroundColor(rednight,greennight,bluenight)
		zombie_attacking(dt)
		bullet_movements(dt)
		steve_shoot(dt)
		kill_shit(dt)
		fuck_upZombie(dt)
		move_zombitch()
		complete_wave(dt)
	end
	
		
end
function love.draw()
	
	camera:set()
	if startup == true then
		startup_draw()

	end
	
	
	
	if camp == true then
		love.graphics.setColor(colorred, colorgreen, colorblue)
		draw_camp()
		camp_stuff()
		DONT_LEAVE_FOOL()
		draw_stats()
		love.graphics.setColor(stevecolor_red, stevecolor_green, stevecolor_blue, h_alpha)
		love.graphics.draw(steve.pic, steve.x, steve.y)
		love.graphics.setColor(red,green,blue)
		love.graphics.setFont(large)
		love.graphics.print("$", camera.x + 5, camera.y + 460)
		love.graphics.print(steve.money, camera.x + 5 + 35, camera.y + 460)
		drawHUD()
	
		

	end
	if menu == true then
		menu_draw()
	end
	
	if horde == true then
		love.graphics.setColor(colorred, colorgreen, colorblue)
		draw_horde()
		time = night
		draw_stats()
		love.graphics.setColor(red,green,blue)
		love.graphics.setFont(large)
		love.graphics.setColor(zombiered, zombiegreen, zombieblue)
		draw_zombie()
		love.graphics.setColor(stevecolor_red, stevecolor_green, stevecolor_blue, h_alpha)
		love.graphics.draw(steve.pic, steve.x, steve.y)
		love.graphics.print("$", camera.x + 5, camera.y + 460)
		
		love.graphics.print(steve.money, camera.x + 5 + 45, camera.y + 460)
		drawHUD()
	
	end
	--Draw Everything After this. So it is in the front Layer.--
	
	love.graphics.setColor(red, green, blue, h_alpha)
	gun_draw()
	draw_bullet()
	

	

	
	
	
	
	
	
	--HUD, Goes in front of everything--
	

	
	camera:unset()
end




--Some shit Misc Fart Garflunkin' randomness--
function party_mode(dt)
	if party_modeActive == true then
		red = red - 50000 * dt
		blue = blue + 25000 * dt
		green = green - 39900 * dt
		rednight = rednight - 50000 * dt
		bluenight = bluenight + 25000 * dt
		greennight = greennight - 39900 * dt
		housecolorred = housecolorred + 12220 * dt
		housecolorblue = housecolorblue - 12500 * dt
		housecolorgreen = housecolorgreen + 50000 * dt
		stevecolor_red = stevecolor_red + 7000 * dt
		stevecolor_green = stevecolor_green - 15000 * dt
		stevecolor_blue = stevecolor_blue + 50000 * dt
	end
	if party_modeActive == false then
		red = 232
		blue = 255
		green = 232
		color_green = 255
		color_blue = 255
		color_red = 255
		housecolorred = 150
		housecolorblue = 150
		housecolorgreen = 150
	end
	
	
	
	
	

	
end
function party_draw(dt)
	if party_modeActive == true then
		colorred = colorred - 20000 * dt
		colorblue = colorblue + 13000 * dt
		colorgreen = colorgreen - 50000 * dt
	end
	
	
end
function buzz_kill()
	if colorblue > 255 then
		colorblue = 0
	end
end

